"use strict";
var core_1 = require("@angular/core");
var HighlightDirective = (function () {
    function HighlightDirective(elementRef) {
        this.elementRef = elementRef;
    }
    HighlightDirective.prototype.onMouseEnter = function () {
        this.highlight();
    };
    HighlightDirective.prototype.onMouseLeave = function () {
        this.highlight();
    };
    HighlightDirective.prototype.highlight = function () {
        if (this.elementRef.nativeElement.className.indexOf(this.classe) === -1) {
            this.elementRef.nativeElement.className += ' ' + this.classe;
        }
        else {
            this.elementRef.nativeElement.classList.remove(this.classe);
        }
    };
    HighlightDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[highlight]',
                },] },
    ];
    /** @nocollapse */
    HighlightDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    HighlightDirective.propDecorators = {
        'classe': [{ type: core_1.Input, args: ['highlight',] },],
        'onMouseEnter': [{ type: core_1.HostListener, args: ['mouseenter',] },],
        'onMouseLeave': [{ type: core_1.HostListener, args: ['mouseleave',] },],
    };
    return HighlightDirective;
}());
exports.HighlightDirective = HighlightDirective;
//# sourceMappingURL=highlight.directive.js.map