"use strict";
var core_1 = require('@angular/core');
var InfiniteScrollDirective = (function () {
    function InfiniteScrollDirective(element) {
        this.element = element;
        this._count = 0;
        this.OnScrollMethod = new core_1.EventEmitter();
        this._element = this.element.nativeElement;
        if (!this.scrollTrigger) {
            this.scrollTrigger = 1;
        }
    }
    InfiniteScrollDirective.prototype.onScroll = function () {
        this._count++;
        if (this._element.scrollTop + this._element.clientHeight >= this._element.scrollHeight) {
            this.OnScrollMethod.emit(null);
        }
        else {
            if (this._element.scrollTop + this._element.clientHeight >= (this._element.scrollHeight - (this._element.scrollHeight * this.scrollTrigger))) {
                this.OnScrollMethod.emit(null);
            }
        }
    };
    InfiniteScrollDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[infinite-scroll]',
                    host: {
                        '(scroll)': 'onScroll($event)'
                    }
                },] },
    ];
    /** @nocollapse */
    InfiniteScrollDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    InfiniteScrollDirective.propDecorators = {
        'scrollTrigger': [{ type: core_1.Input, args: ['scroll-distance',] },],
        'OnScrollMethod': [{ type: core_1.Output },],
    };
    return InfiniteScrollDirective;
}());
exports.InfiniteScrollDirective = InfiniteScrollDirective;
//# sourceMappingURL=infinite-scroll.directive.js.map