"use strict";
var core_1 = require("@angular/core");
var InnerTemplateDirective = (function () {
    function InnerTemplateDirective(viewContainer) {
        this.viewContainer = viewContainer;
    }
    Object.defineProperty(InnerTemplateDirective.prototype, "item", {
        set: function (item) {
            this._item = item;
            if (this.template) {
                this.template.destroy();
                this.criaTemplate();
            }
        },
        enumerable: true,
        configurable: true
    });
    InnerTemplateDirective.prototype.ngOnInit = function () {
        this.criaTemplate();
    };
    InnerTemplateDirective.prototype.criaTemplate = function () {
        if (this.templateRef) {
            this.template = this.viewContainer.createEmbeddedView(this.templateRef, {
                '\$implicit': this._item,
                'index': this.index
            });
        }
    };
    InnerTemplateDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[inner-template]'
                },] },
    ];
    /** @nocollapse */
    InnerTemplateDirective.ctorParameters = function () { return [
        { type: core_1.ViewContainerRef, },
    ]; };
    InnerTemplateDirective.propDecorators = {
        'item': [{ type: core_1.Input },],
        'index': [{ type: core_1.Input },],
        'templateRef': [{ type: core_1.Input, args: ['inner-template',] },],
    };
    return InnerTemplateDirective;
}());
exports.InnerTemplateDirective = InnerTemplateDirective;
//# sourceMappingURL=inner-template.directive.js.map